/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        17.10.2008
 Description:    8_Channel Analog Data View

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
----------------------------------------------------------------------------*/
#include <avr/interrupt.h>
#include <avr/io.h>
#include "usart.h"

volatile unsigned int adc_channel[8];

//############################################################################
//AD Werte einlesen
ISR (ADC_vect)
//############################################################################
{
	static unsigned char channel = 0;
 
	ADCSRA = 0;	
	
	adc_channel[channel++] = ADC;
	if (channel > 7) channel = 0;
	ADMUX =(1<<REFS0) + channel;
	
	ADCSRA=(1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADIE);
}

//############################################################################
//MAIN
int main (void)
//############################################################################
{   
	//USART Init
    usart_init(9600);
	
	//ADC initialisieren
	ADMUX = (1<<REFS0);
	//Free Running Mode, Division Factor 128, Interrupt on
	ADCSRA = (1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADIE);
	
	//Globale Interrupts Enable
	sei();
	
    while(1)
	{
		//Wert 1 senden
		usart_write_char((adc_channel[0] & 0x00FF)); 		//LSB
		usart_write_char((adc_channel[0] & 0x0F00)>>8);	//MSB
		//Wert 2 senden
		usart_write_char((adc_channel[1] & 0x00FF)); 		//LSB
		usart_write_char((adc_channel[1] & 0x0F00)>>8);	//MSB
		//Wert 3 senden
		usart_write_char((adc_channel[2] & 0x00FF)); 		//LSB
		usart_write_char((adc_channel[2] & 0x0F00)>>8);	//MSB
		//Wert 4 senden
		usart_write_char((adc_channel[3] & 0x00FF)); 		//LSB
		usart_write_char((adc_channel[3] & 0x0F00)>>8);	//MSB
		//Wert 5 senden
		usart_write_char((adc_channel[4] & 0x00FF)); 		//LSB
		usart_write_char((adc_channel[4] & 0x0F00)>>8);	//MSB
		//Wert 6 senden
		usart_write_char((adc_channel[5] & 0x00FF)); 		//LSB
		usart_write_char((adc_channel[5] & 0x0F00)>>8);	//MSB
		//Wert 7 senden
		usart_write_char(0);	//LSB
		usart_write_char(0);	//MSB
		//Wert 8 senden
		usart_write_char(0);	//LSB
		usart_write_char(0);	//MSB
	
		//Ende
		usart_write_char(255);
		usart_write_char(255);
	}
}



